package com.mousetech.gourmetj.persistence.model;

import java.io.Serializable;
import jakarta.persistence.*;


/**
 * The persistent class for the "info" database table.
 * 
 */
@Entity
@Table(name="\"info\"")
@NamedQuery(name="Info.findAll", query="SELECT i FROM Info i")
public class Info implements Serializable {
	private static final long serialVersionUID = 1L;

	@Column(name="\"last_access\"")
	private int lastAccess;

	@Id
	@Column(name="\"rowid\"")
	private int rowid;

	@Column(name="\"version_major\"")
	private int versionMajor;

	@Column(name="\"version_minor\"")
	private int versionMinor;

	@Column(name="\"version_super\"")
	private int versionSuper;

	public Info() {
	}

	public int getLastAccess() {
		return this.lastAccess;
	}

	public void setLastAccess(int lastAccess) {
		this.lastAccess = lastAccess;
	}

	public int getRowid() {
		return this.rowid;
	}

	public void setRowid(int rowid) {
		this.rowid = rowid;
	}

	public int getVersionMajor() {
		return this.versionMajor;
	}

	public void setVersionMajor(int versionMajor) {
		this.versionMajor = versionMajor;
	}

	public int getVersionMinor() {
		return this.versionMinor;
	}

	public void setVersionMinor(int versionMinor) {
		this.versionMinor = versionMinor;
	}

	public int getVersionSuper() {
		return this.versionSuper;
	}

	public void setVersionSuper(int versionSuper) {
		this.versionSuper = versionSuper;
	}

}